<!--
 * @Author: zhp
 * @Date: 2023-04-17 14:23:17
 * @LastEditTime: 2023-06-20 15:38:46
 * @LastEditors: zhp
 * @Description: 
-->
<template>
  <el-card shadow="never" class="aui-card--fill">
    <div class="mod-sys__user">
      <SearchBar :formConfigs="formConfig" ref="ruleForm" @headBtnClick="buttonClick">
      </SearchBar>
      <base-table id="palletTable" :table-props="tableProps" :page="listQuery.page" ref="palletTable1"
        @emitFun="inputChange" @emitButtonClick="emitButtonClick" :limit="listQuery.limit" :table-data="tableData">
        <method-btn v-if="tableBtn.length" slot="handleBtn" :width="100" label="操作" :method-list="tableBtn"
          @clickBtn="handleClick" />
      </base-table>
      <pagination :limit.sync="listQuery.limit" :page.sync="listQuery.page" :total="listQuery.total"
        @pagination="getDataList" />
      <!-- 弹窗, 新增 / 修改 -->
      <base-dialog :dialogTitle="addOrEditTitle" :dialogVisible="addOrUpdateVisible" @cancel="handleCancel"
        @confirm="handleConfirm" :before-close="handleCancel">
        <evaluationTask-add ref="addOrUpdate" @refreshDataList="successSubmit">
          </evaluationTask-add>
          <!-- <el-row slot="footer" type="flex" justify="end"> </el-row> -->
      </base-dialog>
      <base-dialog :dialogTitle="searchOrEditTitle" :dialogVisible="searchOrUpdateVisible" @cancel="handleSearchCancel"
        @confirm="handleSearchConfirm" :before-close="handleSearchCancel">
        <supplierProduct-search ref="searchOrUpdate" @successSubmit="conditionSearchSubmit">
        </supplierProduct-search>
        <el-row slot="footer" type="flex" justify="end">
          <el-col :span="12">
            <el-button size="small" type="primary" plain class="btnTextStyle" @click="handleSearchCancel">
              {{ $t("close") }}
            </el-button>
            <el-button size="small" class="btnTextStyle" type="primary" plain @click="handleSearchReset">{{
              $t("reset")
              }}</el-button>
            <el-button type="primary" size="small" class="btnTextStyle" @click="handleSearchConfirm">
              {{ $t("search") }}
            </el-button>
          </el-col>
        </el-row>
      </base-dialog>
    </div>
  </el-card>
</template>

<script>
import basicPage from "@/mixins/basic-page"
import basicSearch from "@/mixins/basic-search"
import supplierProductSearch from "./components/supplierProductSearch.vue"
import evaluationTaskAdd from "./components/evaluationTask-add.vue"
import { timeFormatter } from '@/filters'
import i18n from "@/i18n"
// import i18n from "@/i18n";
const tableProps = [
  {
    prop: "evaluationType",
    label: i18n.t('supplier.evaluationType')
  },
  {
    prop: "title",
    label: i18n.t('supplier.title')
  },
  {
    prop: "evaluationTemplateName",
    label: i18n.t('supplier.evaluationTemplateName')
  },
  {
    prop: "evaluationPeriod",
    label: i18n.t('supplier.evaluationPeriod')
  },
  {
    prop: "description",
    label: i18n.t('supplier.description'),
    filter: timeFormatter
  },
  {
    prop: "startTime",
    label: i18n.t('supplier.startTime')
  }
];
const tableBtn = [
  {
    type: "edit",
    btnName: i18n.t('t.edit'),
  },
  {
    type: "delete",
    btnName: i18n.t('t.delete'),
  }
];
export default {
  mixins: [basicPage, basicSearch],
  data() {
    return {
      urlOptions: {
        getDataListURL: "/supplier/qmsEvaluationTask/page",
        deleteURL: "/supplier/qmsEvaluationTask",
        exportURL: '/supplier/qmsEvaluationTask/export',
        getSupplierListURL: '/supplier/qmsSupplier/page',
        getTemplateListURL: '/supplier/qmsEvaluationTask/page'

        // submitURL: '/supplier/qmsSupplierType'
      },
      tableProps,
      ment: '',
      tableBtn,
      productData: {},
      dataForm:{
        limit: 999,
        page:1
      },
      searchOrEditTitle: "",
      searchOrUpdateVisible: false,
      productOrEditTitle: "",
      addOrEditTitle: '',
      addOrUpdateVisible: false,
      productOrUpdateVisible: false,
      formConfig: [
        {
          type: 'select',
          label: i18n.t('supplier.supplierName'),
          selectOptions: [],
          param: 'supplierName',
          clearable: true,
          filterable: true,
        },
        {
          type: 'select',
          label: i18n.t('supplier.evaluationTemplateName'),
          selectOptions: [],
          param: 'evaluationTemplateId',
          clearable: true,
          filterable: true,
        },
        {
          type: 'datePicker',
          label: i18n.t('supplier.startTime'),
          dateType: 'datetimerange',
          format: 'yyyy-MM-dd HH:mm:ss',
          valueFormat: 'yyyy-MM-ddTHH:mm:ss',
          rangeSeparator: '-',
          startPlaceholder: '开始时间',
          endPlaceholder: '结束时间',
          param: 'timeSlot',
          width: 350
        },
        // {
        //   type: "",
        //   label: i18n.t("params.paramCode"),
        //   placeholder: i18n.t("params.paramCode"),
        //   param: "paramCode",
        // },
        // {
        //   type: "separate",
        // },
        {
          type: "button",
          btnName: i18n.t('search'),
          name: "search",
          color: "primary",
          // plain: true,
        },
        {
          type: "button",
          btnName: i18n.t('add'),
          name: "add",
          color: "primary",
          // plain: true,
        },
        {
          type: "button",
          btnName: i18n.t('export'),
          name: "export",
          color: "primary",
          // plain: true,
        }
      ],
    };
  },
  components: {
    supplierProductSearch,
    // supplierProduct,
    evaluationTaskAdd
  },
  mounted () {
    this.getData();
  },
  methods: {
    inputChange(val) {
      console.log('=======')
      console.log(val)
      this.tableData[val._pageIndex - 1][val.prop] = val[val.prop]
      console.log(this.tableData)
    },
    emitButtonClick() {
      console.log('emitButtonClick')
      let obj = {}
      for (let i of this.tableData) {
        obj[i.prop] = ''
      }
      this.tableData.push(obj)
    },
    getData() {
      this.$http
        .get(this.urlOptions.getSupplierListURL, { params: this.listQuery })
        .then(({ data: res }) => {
          if (res.code === 0) {
            console.log(res.data);
            this.formConfig[0].selectOptions = res.data.list.map((item) => {
              return {
                id: item.name,
                name: item.name,
              }
            })
          }
        })
        .catch(() => {
        })
      this.$http
        .get(this.urlOptions.getTemplateListURL, { params: this.listQuery })
        .then(({ data: res }) => {
          if (res.code === 0) {
            console.log(res.data);
            this.formConfig[1].selectOptions = res.data.list
          }
        })
        .catch(() => {
        })
    },
    //search-bar点击
    handleProductCancel() {
      this.productOrUpdateVisible = false;
      this.productOrEditTitle = "";
    },
    handleCurrentChange(val) {
      console.log(val);
      this.productData = val.newVal ? val.newVal : {}
    },
    setCurrent(index) {
      this.$refs.palletTable1.setCurrent("palletTable", index);
    },
    // handleSearchCancel() {
    //   this.searchOrEditTitle = "";
    //   this.searchOrUpdateVisible = false;
    // },
    conditionSearch() {
      this.searchOrEditTitle = "搜索";
      this.searchOrUpdateVisible = true;
      this.$nextTick(() => {
        this.$refs.searchOrUpdate.init();
      });
    },
    exportHandle() {
      this.$http.get(this.urlOptions.exportURL, { responseType: 'blob' }, {
        ...this.dataForm
      }).then((res) => {
        console.log(res)
        // if (res !== 0) {
        //   return this.$message.error(res.msg) 
        // }
        let fileName = ''
        const contentDisposition = res.headers['content-disposition']
        if (contentDisposition) {
          const temp = res.headers['content-disposition']
            .split(';')[1]
            .split('=')[1]
          // 对文件名乱码转义--【Node.js】使用iconv-lite解决中文乱码
          fileName = decodeURI(temp)
          console.log(temp)
        }
        const blob = new Blob([res.data])
        const reader = new FileReader()
        reader.readAsDataURL(blob)
        reader.onload = (e) => {
          const a = document.createElement('a')
          a.download = fileName
          a.href = e.target.result
          document.body.appendChild(a)
          a.click()
          document.body.removeChild(a)
        }
      }).catch(() => { })
    },
    // handleConfirm() {
    //   this.$refs.addOrUpdate.dataFormSubmitHandle();
    // },
    // conditionSearchSubmit() {},
    conditionSearchSubmit(dataForm) {
      // console.log(key);
      // console.log(key);
      this.listQuery.supplierName = dataForm.supplierName
      this.listQuery.page = 1;
      this.getDataList();
      this.searchOrUpdateVisible = false;
      // console.log(11111);
      // this.conditionSearchSubmit();
    },
    handleClick(val) {
      if (val.type === "delete") {
        this.$confirm(`确定对[名称=${val.data.customerTypeName}]进行删除操作?`, "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        })
          .then(() => {
            this.$http.delete(this.urlOptions.deleteURL, { data: [val.data.id] }).then(({ data }) => {
              if (data && data.code === 0) {
                this.$message({
                  message: "操作成功",
                  type: "success",
                  duration: 1500,
                  onClose: () => {
                    this.getDataList();
                  },
                });
              } else {
                this.$message.error(data.msg);
              }
            });
          })
          .catch(() => { });
      } else if (val.type === 'edit') {
        this.addOrUpdateVisible = true
        this.addOrEditTitle = this.$t('edit')
        this.$nextTick(() => {
          this.$refs.addOrUpdate.init(val.data.id);
        });
      }
    },
    // addOrUpdateHandle(productData) {
    //   this.addOrUpdateVisible = true;
    //   this.$nextTick(() => {
    //     this.$refs.addOrUpdate.init(productData);
    //   });
    // },
    buttonClick(val) {
      console.log(val)
      switch (val.btnName) {
        case "search":
          // this.listQuery.paramCode = val.paramCode;
          this.listQuery.evaluationTemplateId = val.evaluationTemplateId ? val.evaluationTemplateId : undefined
          // this.listQuery.supplierBatch = val.supplierBatch ? val.supplierBatch : undefined
          this.listQuery.supplierName = val.supplierName ? val.supplierName : undefined
          this.listQuery.startTime = val.timeSlot ? val.timeSlot[0] : undefined
          this.listQuery.endTime = val.timeSlot ? val.timeSlot[1] : undefined
          // console.log(i18n);
          this.listQuery.page = 1;
          this.getDataList();
          break;
        case "add":
          this.addOrEditTitle = '新增'
          this.addOrUpdateVisible = true;
          this.addOrUpdateHandle()
          break;
        default:
      }
    },
  },
};
</script>
